---
title: GET /tasks
slug: content-marketing-platform/api/get-tasks
docTags: 
createdAt: 2026-10-01T18:51:26.265Z
---

{
  "id": "zukpOY0sqvIM9CrVGVL9a",
  "type": "api-oas-v2",
  "data": {
    "method": "GET",
    "url": "https://api.cmp.optimizely.com/v3/tasks",
    "servers": [
      {
        "url": "https://api.cmp.optimizely.com/v3/tasks",
        "description": "v3 version of Optimizely CMP Open API"
      }
    ],
    "name": "GET /tasks",
    "description": "<p>Experimental Get a list of tasks.</p>\n<p>Pick one style of date filter per request. Either use <code>start_date</code> and <code>due_date</code>, or use the <code>__from</code> and <code>__to</code> filters. A request that mixes the two styles returns a <code>400</code> error.</p>",
    "contentType": "application/json",
    "request": {
      "pathParameters": [],
      "headerParameters": [
        {
          "name": "accept",
          "type": "string",
          "kind": "optional",
          "description": "Generated from available response content types",
          "enum": [
            "application/json"
          ],
          "default": "application/json"
        }
      ],
      "queryParameters": [
        {
          "kind": "optional",
          "name": "search_key",
          "type": "string",
          "example": "task 1",
          "description": "Search for task title"
        },
        {
          "kind": "optional",
          "name": "campaign",
          "type": "string",
          "example": "8n7f910o51b00b722o0418n30cie8211",
          "description": "Campaign id of the tasks"
        },
        {
          "kind": "optional",
          "name": "workflow",
          "type": "string",
          "example": "8n7f910o51b00b722o0418n30cie8211",
          "description": "Workflow id of the tasks"
        },
        {
          "kind": "optional",
          "name": "milestone",
          "type": "string",
          "example": "8n7f910o51b00b722o0418n30cie8211",
          "description": "Milestone id of the tasks"
        },
        {
          "kind": "optional",
          "name": "start_date",
          "type": "string",
          "example": "2022-08-24T00:00:00.000Z",
          "description": "<p>Warning: Deprecated</p>",
          "deprecated": true
        },
        {
          "kind": "optional",
          "name": "due_date",
          "type": "string",
          "example": "2022-08-24T00:00:00.000Z",
          "description": "<p>Warning: Deprecated</p>",
          "deprecated": true
        },
        {
          "kind": "optional",
          "name": "start_date__from",
          "type": "string<date-time>",
          "example": "2022-08-24T00:00:00Z",
          "description": "<p>Date and time as the lower limit to filter tasks by their start date, in ISO 8601 UTC format</p>",
          "format": "date-time"
        },
        {
          "kind": "optional",
          "name": "start_date__to",
          "type": "string<date-time>",
          "example": "2022-08-31T23:59:59Z",
          "description": "<p>Date and time as the upper limit to filter tasks by their start date, in ISO 8601 UTC format</p>",
          "format": "date-time"
        },
        {
          "kind": "optional",
          "name": "due_date__from",
          "type": "string<date-time>",
          "example": "2022-08-24T00:00:00Z",
          "description": "<p>Date and time as the lower limit to filter tasks by their due date, in ISO 8601 UTC format</p>",
          "format": "date-time"
        },
        {
          "kind": "optional",
          "name": "due_date__to",
          "type": "string<date-time>",
          "example": "2022-08-31T23:59:59Z",
          "description": "<p>Date and time as the upper limit to filter tasks by their due date, in ISO 8601 UTC format</p>",
          "format": "date-time"
        },
        {
          "kind": "optional",
          "name": "status",
          "type": "array",
          "example": "[\"In Progress\",\"Not Started\"]",
          "description": "Filter tasks by status. Provide multiple statuses to filter tasks across multiple statuses.",
          "schema": [],
          "itemType": "string",
          "customType": "string[]"
        },
        {
          "kind": "optional",
          "name": "offset",
          "type": "integer",
          "example": 5,
          "description": "<p>Starting index of results (zero indexed)</p>",
          "default": 0,
          "minimum": 0
        },
        {
          "kind": "optional",
          "name": "page_size",
          "type": "integer",
          "example": 15,
          "description": "Number of results to return per page",
          "default": 10,
          "minimum": 1,
          "maximum": 100
        }
      ],
      "bodyDataParameters": [],
      "formDataParameters": [],
      "oAuthParameters": [
        {
          "id": "OAuth2",
          "name": "OAuth2",
          "kind": "optional",
          "type": "oauth2",
          "oauth2Flows": {
            "clientCredentials": {
              "tokenUrl": "https://accounts.cmp.optimizely.com/o/oauth2/v1/token",
              "scopes": {}
            },
            "authorizationCode": {
              "authorizationUrl": "https://accounts.cmp.optimizely.com/o/oauth2/v1/auth",
              "tokenUrl": "https://accounts.cmp.optimizely.com/o/oauth2/v1/token",
              "scopes": {
                "openid": "Grants the ability to receive a unique identifier for the user.",
                "profile": "Grants access to user profile information.",
                "offline_access": "Grants the ability to refresh access_token using the refresh token even when user is not present (not logged in)."
              }
            }
          },
          "requiredScopes": [
            "openid",
            "profile",
            "offline_access"
          ]
        }
      ],
      "cookieParameters": []
    },
    "responses": [
      {
        "statusCode": "200",
        "description": "List of fetched tasks",
        "jsonExample": "",
        "isExpanded": true,
        "schema": [
          {
            "kind": "optional",
            "type": "object",
            "description": "",
            "schema": [
              {
                "name": "data",
                "kind": "required",
                "type": "array",
                "description": "List of tasks",
                "modelRef": "#/components/schemas/TaskListResponseItem",
                "customType": "TaskListResponseItem[]",
                "schema": [
                  {
                    "name": "id",
                    "kind": "required",
                    "type": "string",
                    "description": "Unique identifier of the task",
                    "example": "837f910551b00a722e0418830cee6612"
                  },
                  {
                    "name": "title",
                    "kind": "required",
                    "type": "string",
                    "description": "Title of the task",
                    "example": "The awesome task"
                  },
                  {
                    "name": "start_at",
                    "kind": "required",
                    "type": "string",
                    "nullable": true,
                    "description": "Start date of the task in ISO 8601 UTC format",
                    "example": "2024-06-01T06:00:00Z"
                  },
                  {
                    "name": "due_at",
                    "kind": "required",
                    "type": "string",
                    "nullable": true,
                    "description": "Due date of the task in ISO 8601 UTC format",
                    "example": "2024-06-01T06:00:00Z"
                  },
                  {
                    "name": "modified_at",
                    "kind": "required",
                    "type": "string",
                    "nullable": true,
                    "description": "Modified date of the task in ISO 8601 UTC format",
                    "example": "2024-06-01T06:00:00Z"
                  },
                  {
                    "name": "reference_id",
                    "kind": "required",
                    "type": "string",
                    "description": "Reference identifier of the task",
                    "example": "TSK-1589"
                  },
                  {
                    "name": "is_completed",
                    "kind": "required",
                    "type": "boolean",
                    "description": "Whether the task is completed or not",
                    "example": false
                  },
                  {
                    "name": "is_archived",
                    "kind": "required",
                    "type": "boolean",
                    "description": "Whether the task is archived or not",
                    "example": false
                  },
                  {
                    "name": "campaign_id",
                    "kind": "required",
                    "type": "string",
                    "nullable": true,
                    "description": "Unique identifier of the campaign",
                    "example": "8n7f910o51b00b722o0418n30cie8211"
                  },
                  {
                    "name": "workflow_id",
                    "kind": "required",
                    "type": "string",
                    "nullable": true,
                    "description": "Unique identifier of the workflow",
                    "example": "8n7f910o51b00b722o0418n30cie8211"
                  },
                  {
                    "name": "milestone_id",
                    "kind": "required",
                    "type": "string",
                    "nullable": true,
                    "description": "Unique identifier of the milestone",
                    "example": "8n7f910o51b00b722o0418n30cie8211"
                  },
                  {
                    "name": "status",
                    "kind": "required",
                    "type": "string<Archived | Completed | Overdue | Not Started | In Progress | On Hold>",
                    "description": "Current status of the task",
                    "example": "Not Started",
                    "enum": [
                      "Archived",
                      "Completed",
                      "Overdue",
                      "Not Started",
                      "In Progress",
                      "On Hold"
                    ]
                  },
                  {
                    "name": "links",
                    "kind": "required",
                    "type": "object",
                    "description": "Meta links",
                    "example": "",
                    "schema": [
                      {
                        "name": "self",
                        "kind": "required",
                        "type": "string",
                        "description": "URL of the task",
                        "example": "https://api.cmp.optimizely.com/v3/tasks/5d7f910551b00a722e0418830cee5534"
                      },
                      {
                        "name": "campaign",
                        "kind": "required",
                        "type": "string",
                        "nullable": true,
                        "description": "URL of the campaign that the task is associated with",
                        "example": "https://api.cmp.optimizely.com/v3/campaigns/2e7f9107351b00a722e0412230cee5534"
                      },
                      {
                        "name": "workflow",
                        "kind": "required",
                        "type": "string",
                        "nullable": true,
                        "description": "URL of the workflow the task",
                        "example": "https://api.cmp.optimizely.com/v3/workflows/63f1c2b675be4132854d2741"
                      },
                      {
                        "name": "milestone",
                        "kind": "required",
                        "type": "string",
                        "nullable": true,
                        "description": "URL of the milestone that the task is associated with",
                        "example": "https://api.cmp.optimizely.com/v3/milestones/63f1c2b675be4132854d2741"
                      },
                      {
                        "name": "web_urls",
                        "kind": "required",
                        "type": "object",
                        "description": "Web URLs",
                        "example": "",
                        "schema": [
                          {
                            "name": "self",
                            "kind": "required",
                            "type": "string",
                            "description": "Web URL of the task",
                            "example": "https://cmp.optimizely.com/cloud/taskv3/5c52cc153db27d0e5141146f"
                          }
                        ]
                      }
                    ]
                  }
                ]
              },
              {
                "name": "pagination",
                "kind": "required",
                "type": "object",
                "description": "",
                "complexType": "allOf",
                "complexItems": [
                  {
                    "name": "Pagination",
                    "description": "",
                    "modelRef": "#/components/schemas/Pagination",
                    "schema": [
                      {
                        "name": "next",
                        "kind": "required",
                        "type": "string",
                        "nullable": true,
                        "description": "URL to the next page",
                        "example": "https://api.cmp.optimizely.com/<some-path-to-next-page>?offset=10&page_size=10"
                      },
                      {
                        "name": "previous",
                        "kind": "required",
                        "type": "string",
                        "nullable": true,
                        "description": "URL to the previous page",
                        "example": ""
                      }
                    ]
                  },
                  {
                    "name": "object",
                    "description": "",
                    "schema": [
                      {
                        "name": "next",
                        "kind": "optional",
                        "type": "string",
                        "nullable": true,
                        "description": "",
                        "example": "https://api.cmp.optimizely.com/v3/tasks?offset=10&page_size=10"
                      }
                    ]
                  }
                ],
                "schema": []
              }
            ],
            "isExpanded": true
          }
        ]
      },
      {
        "statusCode": "401",
        "description": "Authorization error",
        "jsonExample": "",
        "isExpanded": true,
        "schema": [
          {
            "kind": "optional",
            "type": "object",
            "example": "{\"message\":\"Unauthorized\"}",
            "description": "Error payload",
            "customType": "Error",
            "schema": [
              {
                "name": "message",
                "kind": "required",
                "type": "string",
                "description": "Message describing the error",
                "example": "Not found"
              },
              {
                "name": "errors",
                "kind": "optional",
                "type": "map",
                "description": "Additional information",
                "example": "",
                "customType": "map<string, string>",
                "schema": []
              }
            ],
            "modelRef": "#/components/schemas/Error",
            "isExpanded": true
          }
        ]
      },
      {
        "statusCode": "403",
        "description": "Permission error",
        "jsonExample": "",
        "isExpanded": true,
        "schema": [
          {
            "kind": "optional",
            "type": "object",
            "example": "{\"message\":\"You do not have the permission to perform this operation\"}",
            "description": "Error payload",
            "customType": "Error",
            "schema": [
              {
                "name": "message",
                "kind": "required",
                "type": "string",
                "description": "Message describing the error",
                "example": "Not found"
              },
              {
                "name": "errors",
                "kind": "optional",
                "type": "map",
                "description": "Additional information",
                "example": "",
                "customType": "map<string, string>",
                "schema": []
              }
            ],
            "modelRef": "#/components/schemas/Error",
            "isExpanded": true
          }
        ]
      }
    ],
    "hasXCodeSamples": false,
    "examples": {
      "languages": [
        {
          "id": "HeCCVEIqkKywIn-yZ7_Z8",
          "language": "curl",
          "label": "cURL",
          "code": "curl --request GET \\\n     --url 'https://api.cmp.optimizely.com/v3/tasks?offset=5&page_size=10' \\\n     --header 'accept: application/json'"
        },
        {
          "id": "r0KAeuMw521mE6IU3Gg6v",
          "language": "javascript",
          "label": "javascript",
          "code": "var myHeaders = new Headers();\nmyHeaders.append(\"accept\", \"application/json\");\nmyHeaders.append(\"content-type\", \"application/json\");\n\nvar requestOptions = {\n   method: 'GET',\n   headers: myHeaders,\n   redirect: 'follow'\n};\n\nfetch(\"https://api.cmp.optimizely.com/v3/tasks?offset=5&page_size=10\", requestOptions)\n   .then(response => response.text())\n   .then(result => console.log(result))\n   .catch(error => console.log('error', error));"
        },
        {
          "id": "ZB6xXGeooSZdMAmZslj-M",
          "language": "ruby",
          "label": "Ruby",
          "code": "require \"uri\"\nrequire \"json\"\nrequire \"net/http\"\n\nurl = URI(\"https://api.cmp.optimizely.com/v3/tasks?offset=5&page_size=10\")\n\nhttps = Net::HTTP.new(url.host, url.port)\nhttps.use_ssl = true\n\nrequest = Net::HTTP::Get.new(url)\nrequest[\"accept\"] = \"application/json\"\nrequest[\"content-type\"] = \"application/json\"\n\nresponse = https.request(request)\nputs response.read_body\n"
        },
        {
          "id": "RBR68R9mlYt6ehUBx1Z98",
          "language": "python",
          "label": "Python",
          "code": "import requests\nimport json\n\nurl = \"https://api.cmp.optimizely.com/v3/tasks?offset=5&page_size=10\"\n\npayload = {}\nheaders = {\n   'accept': 'application/json',\n   'content-type': 'application/json'\n}\n\nresponse = requests.request(\"GET\", url, headers=headers, data=payload)\n\nprint(response.text)\n"
        }
      ],
      "selectedLanguageId": "HeCCVEIqkKywIn-yZ7_Z8"
    },
    "results": {
      "languages": [
        {
          "id": "response-0-200",
          "language": "200",
          "code": "// List of fetched tasks\n{\n  \"data\": [\n    {\n      \"id\": \"837f910551b00a722e0418830cee6612\",\n      \"title\": \"The awesome task\",\n      \"start_at\": \"2024-06-01T06:00:00Z\",\n      \"due_at\": \"2024-06-01T06:00:00Z\",\n      \"modified_at\": \"2024-06-01T06:00:00Z\",\n      \"reference_id\": \"TSK-1589\",\n      \"is_completed\": false,\n      \"is_archived\": false,\n      \"campaign_id\": \"8n7f910o51b00b722o0418n30cie8211\",\n      \"workflow_id\": \"8n7f910o51b00b722o0418n30cie8211\",\n      \"milestone_id\": \"8n7f910o51b00b722o0418n30cie8211\",\n      \"status\": \"Not Started\",\n      \"links\": {\n        \"self\": \"https://api.cmp.optimizely.com/v3/tasks/5d7f910551b00a722e0418830cee5534\",\n        \"campaign\": \"https://api.cmp.optimizely.com/v3/campaigns/2e7f9107351b00a722e0412230cee5534\",\n        \"workflow\": \"https://api.cmp.optimizely.com/v3/workflows/63f1c2b675be4132854d2741\",\n        \"milestone\": \"https://api.cmp.optimizely.com/v3/milestones/63f1c2b675be4132854d2741\",\n        \"web_urls\": {\n          \"self\": \"https://cmp.optimizely.com/cloud/taskv3/5c52cc153db27d0e5141146f\"\n        }\n      }\n    }\n  ],\n  \"pagination\": {}\n}"
        },
        {
          "id": "response-1-401",
          "language": "401",
          "code": "// Authorization error\n{\n  \"message\": \"Not found\",\n  \"errors\": \"\"\n}"
        },
        {
          "id": "response-2-403",
          "language": "403",
          "code": "// Permission error\n{\n  \"message\": \"Not found\",\n  \"errors\": \"\"\n}"
        }
      ],
      "selectedLanguageId": "response-0-200"
    }
  },
  "children": [
    {
      "text": ""
    }
  ]
}